// Code scaffolded by goctl. Safe to edit.
// goctl 1.9.2

package auth

import (
	"context"
	"errors"
	"juwan-backend/app/users/rpc/usercenter"
	"juwan-backend/common/utils/contextj"

	"juwan-backend/app/users/api/internal/svc"
	"juwan-backend/app/users/api/internal/types"

	"github.com/zeromicro/go-zero/core/logx"
)

type LogoutLogic struct {
	logx.Logger
	ctx    context.Context
	svcCtx *svc.ServiceContext
}

// 退出登录
func NewLogoutLogic(ctx context.Context, svcCtx *svc.ServiceContext) *LogoutLogic {
	return &LogoutLogic{
		Logger: logx.WithContext(ctx),
		ctx:    ctx,
		svcCtx: svcCtx,
	}
}

func (l *LogoutLogic) Logout(_ *types.LogoutReq) (resp *types.EmptyResp, err error) {
	// todo: add your logic here and delete this line
	userId, err := contextj.UserIDFrom(l.ctx)
	if err != nil {
		return nil, errors.New("illegal id")
	}
	if userId <= 0 {
		return nil, errors.New("invalid userId")
	}

	_, err = l.svcCtx.UserRpc.Logout(l.ctx, &usercenter.LogoutReq{UserId: userId})
	if err != nil {
		return nil, err
	}
	return &types.EmptyResp{}, nil
}
